import * as cli from '@rushstack/ts-command-line';
import { Umzug } from './umzug';
export declare abstract class ApplyMigrationsAction extends cli.CommandLineAction {
    protected readonly umzug: Umzug<{}>;
    private _params;
    protected constructor(umzug: Umzug<{}>, cliOptions: cli.ICommandLineActionOptions);
    private static _defineParameters;
    onDefineParameters(): void;
    protected getParams(): {
        to: string | undefined;
        step: number | undefined;
        migrations: readonly string[];
        rerun: string | undefined;
    };
}
export declare class UpAction extends ApplyMigrationsAction {
    constructor(umzug: Umzug<{}>);
    onExecute(): Promise<void>;
}
export declare class DownAction extends ApplyMigrationsAction {
    constructor(umzug: Umzug<{}>);
    onExecute(): Promise<void>;
}
export declare class ListAction extends cli.CommandLineAction {
    private readonly action;
    private readonly umzug;
    private _params;
    constructor(action: 'pending' | 'executed', umzug: Umzug<{}>);
    private static _defineParameters;
    onDefineParameters(): void;
    onExecute(): Promise<void>;
}
export declare class CreateAction extends cli.CommandLineAction {
    readonly umzug: Umzug<{}>;
    private _params;
    constructor(umzug: Umzug<{}>);
    private static _defineParameters;
    onDefineParameters(): void;
    onExecute(): Promise<void>;
}
export declare class UmzugCLI extends cli.CommandLineParser {
    readonly umzug: Umzug<{}>;
    constructor(umzug: Umzug<{}>);
    onDefineParameters(): void;
}
